class Model {
	/** coordinates relative view */
	Coord3D mCoords[];
	Polygon mPolygons[];

	Model(Coord3D[] coordinates, Polygon[] polygons) {
		mCoords = coordinates;
		mPolygons = polygons;
	}
	/*
	SceneryObject setCoordinates(Coord3D[] coordinates) {
		mCoords = coordinates;
		return this;
	}
	*/
	final Coord3D[] copyCoords() {
		Coord3D[] coords = new Coord3D[mCoords.length];
		for( int i = 0; i < mCoords.length; i++ ) {
			coords[i] = new Coord3D( mCoords[i].mX, mCoords[i].mY, mCoords[i].mZ );
		}
		return coords;
	}
	/*
	final SceneryObject setPolygons(Polygon[] polygons) {
		mPolygons = polygons;
		return this;
	}
	*/
	final Model scale(int x, int y, int z) {
		for( int i = 0; i < mCoords.length; i++ ) {
			mCoords[i].mX *= x;
			mCoords[i].mY *= y;
			mCoords[i].mZ *= z;
		}
		return this;
	}
	final Model shift(int dx, int dy, int dz) {
		for( int i = 0; i < mCoords.length; i++ ) {
			mCoords[i].mX += dx;
			mCoords[i].mY += dy;
			mCoords[i].mZ += dz;
		}
		return this;
	}
	final Model rotateAroundZ(int z_angle) {
		z_angle = (z_angle < -Camera.ANGLE_180) ? (Camera.ANGLE_360 + z_angle) : ((z_angle > Camera.ANGLE_180) ? (z_angle - Camera.ANGLE_360) : z_angle);
		final int abs_angle = Math.abs( z_angle );
		// around z
		//x = x * cos z - y * sin z
		//y = y * cos z + x * sin z
		//
		int sin_z;
		int cos_z;
		if( abs_angle <= Camera.ANGLE_90 ) {
			cos_z = (int)Camera.sCosTable[abs_angle];
			sin_z = (int)Camera.sCosTable[Camera.ANGLE_90 - abs_angle];
		} else {
			cos_z = -(int)Camera.sCosTable[Camera.ANGLE_180 - abs_angle];
			sin_z = (int)Camera.sCosTable[abs_angle - Camera.ANGLE_90];
		}
		if( z_angle < 0 ) sin_z = -sin_z;
		for( int i = 0; i < mCoords.length; i++ ) {
			int x = mCoords[i].mX;
			int y = mCoords[i].mY;
			mCoords[i].mX = (x * cos_z - y * sin_z) / Camera.PRECISION;
			mCoords[i].mY = (y * cos_z + x * sin_z) / Camera.PRECISION;
		}
		return this;
	}
}