import java.awt.Color;

class SceneryData {
	// Scenery colors
	private static final Color COLOR_HILL = new Color( 0x55, 0x77, 0x77 );
	private static final Color COLOR_TALLER_LIGHT = new Color( 0x99, 0xbb, 0x33 );
	private static final Color COLOR_TALLER_DARK = new Color( 0x55, 0x77, 0x77 );
	private static final Color COLOR_BUILDING_LIGHT = Color.WHITE;
	private static final Color COLOR_BUILDING_DARK = new Color( 0xbb, 0xbb, 0xbb );
	private static final Color COLOR_LAKE = new Color( 0x55, 0xbb, 0xff );
	private static final Color COLOR_SNOW = Color.WHITE;
	private static final Color COLOR_SNOW_SHADOW = new Color( 0x99, 0xbb, 0x33 );
	private static final Color COLOR_SNOW_DARK = new Color( 0x55, 0x77, 0x77 );
	//
	private static final Polygon[] POLYGON_HILL = new Polygon[] { new Polygon( COLOR_HILL, new int[] { 1, 0, 2, 3 } ) };
	// objects, y-coordinates must be less than horizon line distance
	static final Model mHill_1 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0x180, 32768, 0 ),
			new Coord3D( 0x4b, 32768, 0x1c ), new Coord3D( 0x104, 32768, 0x10 )
		}, POLYGON_HILL );
	static final Model mHill_2 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0x100, 32768, 0 ),
			new Coord3D( 0x7d, 32768, 0x12 ), new Coord3D( 0xc0, 32768, 0x1e )
		}, POLYGON_HILL );
	static final Model mHill_3 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0x180, 32768, 0 ),
			new Coord3D( 0x64, 32768, 0x14 ), new Coord3D( 0x136, 32768, 0x25 )
		}, POLYGON_HILL );
	static final Model mHill_4 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0x100, 32768, 0 ),
			new Coord3D( 0x46, 32768, 0x18 ), new Coord3D( 0xd8, 32768, 0x24 )
		}, POLYGON_HILL );
	static final Model mHill_5 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0x180, 32768, 0 ),
			new Coord3D( 0xc8, 32768, 0x27 ), new Coord3D( 0xf0, 32768, 0x1f )
		}, POLYGON_HILL );
	static final Model mHill_6 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0x100, 32768, 0 ),
			new Coord3D( 0x32, 32768, 0xc ), new Coord3D( 0xa8, 32768, 0x1a )
		}, POLYGON_HILL );
	static final Model mHill_7 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0x172, 32768, 0 ),
			new Coord3D( 0x70, 32768, 0x19 ), new Coord3D( 0xe6, 32768, 0x14 )
		}, POLYGON_HILL );
	static final Model mHill_8 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0xfa, 32768, 0 ),
			new Coord3D( 0x64, 32768, 0xc ), new Coord3D( 0xbb, 32768, 0x12 )
		}, POLYGON_HILL );
	static final Model mHill_9 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0x180, 32768, 0 ),
			new Coord3D( 0xc6, 32768, 0x1c ), new Coord3D( 0x13b, 32768, 0x18 )
		}, POLYGON_HILL );
	static final Model mHill_10 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0x100, 32768, 0 ),
			new Coord3D( 0x23, 32768, 0x28 ), new Coord3D( 0x6e, 32768, 0x37 )
		}, POLYGON_HILL );
	static final Model mHill_11 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0x159, 32768, 0 ),
			new Coord3D( 0x5c, 32768, 0x2a ), new Coord3D( 0xf0, 32768, 0x1e )
		}, POLYGON_HILL );
	static final Model mHill_12 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0xfa, 32768, 0 ),
			new Coord3D( 0x2d, 32768, 0xf ), new Coord3D( 0x80, 32768, 0xb )
		}, POLYGON_HILL );
	static final Model mHill_13 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0x17c, 32768, 0 ),
			new Coord3D( 0x88, 32768, 0x2b ), new Coord3D( 0xd2, 32768, 0x23 )
		}, POLYGON_HILL );
	static final Model mHill_14 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0x100, 32768, 0 ),
			new Coord3D( 0x4b, 32768, 0x29 ), new Coord3D( 0x9b, 32768, 0x37 )
		}, POLYGON_HILL );
	//
	private static final Polygon[] POLYGON_TALLER = new Polygon[] {
		new Polygon( COLOR_TALLER_LIGHT, new int[] { 2, 0, 3 } ),
		new Polygon( COLOR_TALLER_DARK, new int[] { 1, 2, 3 } )
	};
	static final Model mTaller_1 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0x17c, 32768, 0 ),
			new Coord3D( 0x88, 32768, 0 ), new Coord3D( 0x2b, 32768, 0xd2 )
		}, POLYGON_TALLER );
	static final Model mTaller_2 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0x100, 32768, 0 ),
			new Coord3D( 0x4b, 32768, 0 ), new Coord3D( 0x29, 32768, 0x9b )
		}, POLYGON_TALLER );
	//
	private static final Polygon[] POLYGON_BUILDING = new Polygon[] {
		new Polygon( COLOR_BUILDING_LIGHT, new int[] { 1, 0, 3, 4 } ),
		new Polygon( COLOR_BUILDING_DARK, new int[] { 2, 1, 4, 5 } )
	};
	static final Model mBuilding_1 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0x10, 32768, 0 ),
			new Coord3D( 0x18, 32768, 0 ), new Coord3D( 0, 32768, 0x50 ),
			new Coord3D( 0x10, 32768, 0x50 ), new Coord3D( 0x18, 32768, 0x50 )
		}, POLYGON_BUILDING );
	static final Model mBuilding_2 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0x10, 32768, 0 ),
			new Coord3D( 0x18, 32768, 0 ), new Coord3D( 0, 32768, 0x3c ),
			new Coord3D( 0x10, 32768, 0x3c ), new Coord3D( 0x18, 32768, 0x3c )
		}, POLYGON_BUILDING );
	static final Model mBuilding_3 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0x28, 32768, 0 ),
			new Coord3D( 0x3c, 32768, 0 ), new Coord3D( 0, 32768, 0x39 ),
			new Coord3D( 0x28, 32768, 0x39 ), new Coord3D( 0x3c, 32768, 0x39 )
		}, POLYGON_BUILDING );
	static final Model mBuilding_4 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0x69, 32768, 0 ),
			new Coord3D( 0x7d, 32768, 0 ), new Coord3D( 0, 32768, 0x2a ),
			new Coord3D( 0x69, 32768, 0x2a ), new Coord3D( 0x7d, 32768, 0x2a )
		}, POLYGON_BUILDING );
	//
	static final Model mLake = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 8 ), new Coord3D( 0x32, 32768, 0 ),
			new Coord3D( 0x28a, 32768, 0 ), new Coord3D( 0x2bc, 32768, 8 )
		}, new Polygon[] {
			new Polygon( COLOR_LAKE, new int[] { 2, 1, 0, 3 } )
		} );
	//
	private static final Polygon[] POLYGON_SNOWCAPPED = new Polygon[] {
		new Polygon( COLOR_SNOW_SHADOW, new int[] { 1, 0, 5, 4 } ),
		new Polygon( COLOR_SNOW_DARK, new int[] { 2, 1, 4 } ),
		new Polygon( COLOR_SNOW_DARK, new int[] { 3, 2, 4, 6 } ),
		new Polygon( COLOR_SNOW, new int[] { 4, 5, 6 } ),
	};
	static final Model mSnowcapped_1 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0xfa, 32768, 0 ),
			new Coord3D( 0x1a4, 32768, 0 ), new Coord3D( 0x253, 32768, 0 ),
			new Coord3D( 0x181, 32768, 0x2e ), new Coord3D( 0x118, 32768, 0x34 ),
			new Coord3D( 0x19f, 32768, 0x73 )
		}, POLYGON_SNOWCAPPED );
	static final Model mSnowcapped_2 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0x4b, 32768, 0 ),
			new Coord3D( 0x127, 32768, 0 ), new Coord3D( 0x1f4, 32768, 0 ),
			new Coord3D( 0xaf, 32768, 0x32 ), new Coord3D( 0x87, 32768, 0x3c ),
			new Coord3D( 0xff, 32768, 0x4f )
		}, POLYGON_SNOWCAPPED );
	static final Model mSnowcapped_3 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0x87, 32768, 0 ),
			new Coord3D( 0xc5, 32768, 0 ), new Coord3D( 0xfa, 32768, 0 ),
			new Coord3D( 0x96, 32768, 0x46 ), new Coord3D( 0x69, 32768, 0x50 ),
			new Coord3D( 0xaa, 32768, 0x5f )
		}, POLYGON_SNOWCAPPED );
	static final Model mSnowcapped_4 = new Model( new Coord3D[] {
			new Coord3D( 0, 32768, 0 ), new Coord3D( 0x87, 32768, 0 ),
			new Coord3D( 0x113, 32768, 0 ), new Coord3D( 0x1a9, 32768, 0 ),
			new Coord3D( 0x91, 32768, 0x2a ), new Coord3D( 0x3c, 32768, 0x32 ),
			new Coord3D( 0x8c, 32768, 0x4d )
		}, POLYGON_SNOWCAPPED );
	// scenes
	static final Model mHills[] = {
		mHill_1, mHill_14, mHill_11, mHill_12, mHill_13,
		mHill_6, mHill_3, mHill_4, mHill_1, mHill_2,
		mHill_5, mHill_6, mHill_3, mHill_2, mHill_1,
		mHill_6, mHill_3, mHill_4, mHill_5, mHill_6,
		mHill_1, mHill_10, mHill_7, mHill_8, mHill_9,
		mHill_6, mHill_1, mHill_4, mHill_5, mHill_2,
		mHill_3, mHill_6
	};
	//
	static final Model mTallers[] = {
		mTaller_1, mTaller_2, mTaller_2, mTaller_1, mTaller_2,
		mTaller_1, mTaller_1, mTaller_2, mTaller_1, mTaller_2,
		mTaller_1, mTaller_2, mTaller_2, mTaller_1, mTaller_2,
		mTaller_1, mTaller_1, mTaller_2, mTaller_2, mTaller_1,
		mTaller_2, mTaller_2, mTaller_1, mTaller_1, mTaller_2,
		mTaller_1, mTaller_2, mTaller_2, mTaller_1, mTaller_1,
		mTaller_1, mTaller_2
	};
	//
	static final Model mSnowcapped[] = {
		mSnowcapped_1, mSnowcapped_2, mSnowcapped_3, mSnowcapped_4, mSnowcapped_2,
		mSnowcapped_1, mSnowcapped_2, mSnowcapped_3, mSnowcapped_3, mSnowcapped_1,
		mSnowcapped_4, mSnowcapped_2, mSnowcapped_4, mSnowcapped_3, mSnowcapped_3,
		mSnowcapped_1, mSnowcapped_4, mSnowcapped_2, mSnowcapped_2, mSnowcapped_3,
		mSnowcapped_1, mSnowcapped_1, mSnowcapped_4, mSnowcapped_3, mSnowcapped_2,
		mSnowcapped_1, mSnowcapped_4, mSnowcapped_4, mSnowcapped_2, mSnowcapped_3,
		mSnowcapped_1, mSnowcapped_4
	};
	//
	static final Model mBuildings[] = {
		mBuilding_1, mBuilding_2, mBuilding_3, mBuilding_4, mBuilding_4,
		mBuilding_2, mBuilding_1, mBuilding_1, mBuilding_2, mBuilding_3,
		mBuilding_3, mBuilding_1, mBuilding_1, mBuilding_2, mBuilding_4,
		mBuilding_3, mBuilding_2, mBuilding_1, mBuilding_2, mBuilding_2,
		mBuilding_4, mBuilding_3, mBuilding_1, mBuilding_2, mBuilding_4,
		mBuilding_4, mBuilding_3, mBuilding_1, mBuilding_2, mBuilding_1,
		mBuilding_2, mBuilding_4
	};
	//
	static final Model mMixed[] = {
		mSnowcapped_1, mHill_1, mSnowcapped_3, mHill_2, mSnowcapped_2,
		mHill_3, mSnowcapped_2, mHill_4, mSnowcapped_3, mHill_5,
		mSnowcapped_4, mHill_6, mBuilding_1, mLake, mBuilding_2,
		mLake, mBuilding_4, mBuilding_3, mHill_13, mSnowcapped_4,
		mHill_7, mSnowcapped_1, mHill_8, mSnowcapped_3, mHill_9,
		mSnowcapped_1, mHill_10, mSnowcapped_4, mHill_11, mSnowcapped_3,
		mHill_12, mSnowcapped_4
	};
	/*
	static final Model mSceneryes[][] = {
		mHills, mTallers, mSnowcapped, mBuildings, mMixed
	};
	*/
}
